use crate::authentication::IdentityProviderHandler;
use async_trait::async_trait;
use http_api_isahc_client::IsahcClient;
use oauth2_client::re_exports::{ClientId, ClientSecret, RedirectUri};
use oauth2_instagram::{InstagramExtensionsBuilder, InstagramProviderForBasicDisplayApi, InstagramScope};
use oauth2_signin::web_app::{SigninFlow, SigninFlowHandleCallbackByQueryConfiguration, SigninFlowHandleCallbackRet};

pub use oauth2_instagram;

#[derive(Default)]
pub struct InstagramIdentityProviderHandler {}

#[async_trait]
impl IdentityProviderHandler for InstagramIdentityProviderHandler {
    async fn handle_callback(
        &self,
        client_id: ClientId,
        client_secret: ClientSecret,
        redirect_uri: RedirectUri,
        query: String,
    ) -> Result<SigninFlowHandleCallbackRet, Box<dyn std::error::Error>> {
        let client = IsahcClient::new()?;
        let provider = InstagramProviderForBasicDisplayApi::new(client_id, client_secret, redirect_uri)?;
        let scopes = vec![InstagramScope::UserProfile];
        let flow = SigninFlow::new(client, provider, scopes, InstagramExtensionsBuilder);
        let config = SigninFlowHandleCallbackByQueryConfiguration::new();
        Ok(flow.handle_callback_by_query(query, config).await)
    }
}
